searchNodes=[{"doc":"Send and receive Bitcoin transactions from your Phoenix or Plug-based Elixir application.Txpost implements a standard for encoding and decoding Bitcoin transactions and other data in a concise binary format using CBOR. A number of modules following the Plug specification can easily be slotted in your Phoenix or Plug-based application's pipeline. An optional Router module is available, allowing you to implement routing logic for different types of transactions from a single endpoint.Receive Bitcoin transactions in a concise and efficient binary serialisation formatSimple and flexible schema for sending Bitcoin data with other data parametersSend multiple transactions in a single request, or build streaming applicationsSign and verify data payloads with ECDSA signaturesBRFC specificationsTxpost is an implementation of the following BRFC specifications. They describe a standard for serialising Bitcoin transactions and associated parameters, along with arbitrary meta data, in a concise binary format using CBOR:BRFC c9a2975b3d19 - CBOR Tx Payload specificationBRFC 5b82a2ed7b16 - CBOR Tx Envelope specificationInstallationThe package can be installed by adding txpost to your list of dependencies in mix.exs.def deps do [ {:txpost, &quot;~&gt; 0.1&quot;} ] endAdd Txpost.Parsers.CBOR to your endpoint's list of parsers.plug Plug.Parsers, parsers: [ :json, Txpost.Parsers.CBOR ]Finally create any routes needed to handle transaction requests and add Txpost.Plug to the plug pipeline. For example, adding a route to a Phoenix router:defmodule MyAppWeb.Router do use MyAppWeb, :router pipeline :tx_api do plug :accepts, [&quot;cbor&quot;] plug Txpost.Plug end scope &quot;/tx&quot; do pipe_through :tx_api post &quot;/create&quot;, MyAppWeb.TxController, :create end endTransaction routingThe example above creates a single route passing all transactions to the same controller. You could create many routes for different transactions but in some applications it may be desirable to advertise a single endpoint to receive different types of transactions, each handled by different controllers. In this case Txpost.Router can be used to route transactions to different controllers, using any logic you need.A tx router is a module that implements the Txpost.Router.handle_tx/2 callback.defmodule MyApp.TxRouter do use Txpost.Router def handle_tx(conn, _params) do case get_req_meta(conn) do %{&quot;type&quot; =&gt; &quot;article&quot;} -&gt; ArticleController.call(conn, :create) %{&quot;type&quot; =&gt; &quot;image&quot;} -&gt; ImageController.call(conn, :create) end end endFor more details, see Txpost.Router.","ref":"Txpost.html","title":"Txpost","type":"module"},{"doc":"CBOR Envelope module, implements BRFC 5b82a2ed7b16 (CBOR Tx Envelope).BRFC 5b82a2ed7b16 defines a standard for serializing a CBOR payload in order to have consistnency when signing the payload with a ECDSA keypair.The :payload attribute is a CBOR encoded binary Payload.The :pubkey and :signature attributes are optional binaries.ExamplesExample envelope with an unsigned payload.%Txpost.Envelope{ payload: &lt;&lt;161, 100, 100, 97, 116, 97, 161, 101, 114, 97, 119, 116, 120, 106, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0&gt;&gt; }Example envelope with an signed payload.%Txpost.Envelope{ payload: &lt;&lt;161, 100, 100, 97, 116, 97, 161, 101, 114, 97, 119, 116, 120, 106, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0&gt;&gt;, pubkey: &lt;&lt;2, 170, 75, 142, 232, 142, 111, 76, 138, 31, 212, 197, 4, 20, 227, 157, 8, 252, 150, 79, 61, 83, 205, 99, 54, 225, 193, 254, 122, 200, 147, 51, 180&gt;&gt;, signature: &lt;&lt;48, 68, 2, 32, 24, 134, 241, 47, 243, 122, 86, 199, 199, 220, 173, 209, 38, 189, 238, 84, 197, 20, 218, 193, 190, 35, 88, 95, 214, 137, 204, 206, 156, 21, 223, 5, 2, 32, 67, 243, 10, 255, 17, 52, 68, 176, 250, 253, 199, 208, 16, 167, 132, 183, 206, 49, 147, 241, 61, 117, 231, 254, 197, 52, 109, 45, 247, 78, 210, 62&gt;&gt; }","ref":"Txpost.Envelope.html","title":"Txpost.Envelope","type":"module"},{"doc":"Validates the given parameters and returns an Envelope struct or returns a validation error message.Parameters can be passed as either a map or keyword list. The payload attribute can be an already encoded CBOR binary or a Payload struct.Examplesiex&gt; Txpost.Envelope.build(%{ ...&gt; payload: %Txpost.Payload{data: %{&quot;rawtx&quot; =&gt; &lt;&lt;1, 0 ,0 ,0 ,0 ,0 ,0 ,0 ,0 ,0 &gt;&gt;}} ...&gt; }) {:ok, %Txpost.Envelope{ payload: &lt;&lt;161, 100, 100, 97, 116, 97, 161, 101, 114, 97, 119, 116, 120, 74, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0&gt;&gt;, pubkey: nil, signature: nil }}Returns an error when given invalid params.iex&gt; Txpost.Envelope.build(payload: [&quot;not a valid payload&quot;]) {:error, &quot;Invalid param: payload&quot;}","ref":"Txpost.Envelope.html#build/1","title":"Txpost.Envelope.build/1","type":"function"},{"doc":"Decodes the given CBOR binary and returns an Envelope struct or returns a validation error message.Examplesiex&gt; Txpost.Envelope.decode(&lt;&lt;161, 103, 112, 97, 121, 108, 111, 97, 100, 120, 24, 161, 100, 100, 97, 116, 97, 161, 101, 114, 97, 119, 116, 120, 106, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0&gt;&gt;) {:ok, %Txpost.Envelope{ payload: &lt;&lt;161, 100, 100, 97, 116, 97, 161, 101, 114, 97, 119, 116, 120, 106, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0&gt;&gt;, pubkey: nil, signature: nil }}Returns an error when given invalid binary.iex&gt; Txpost.Envelope.decode(&lt;&lt;0,1,2,3&gt;&gt;) {:error, &quot;Invalid payload binary&quot;}","ref":"Txpost.Envelope.html#decode/1","title":"Txpost.Envelope.decode/1","type":"function"},{"doc":"Decodes the payload of the given Envelope struct and returns a Payload struct or returns a validation error message.Examplesiex&gt; Txpost.Envelope.decode_payload(%Txpost.Envelope{ ...&gt; payload: &lt;&lt;161, 100, 100, 97, 116, 97, 161, 101, 114, 97, 119, 116, 120, 106, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0&gt;&gt; ...&gt; }) {:ok, %Txpost.Payload{ data: %{&quot;rawtx&quot; =&gt; &lt;&lt;1, 0, 0, 0, 0, 0, 0, 0, 0, 0&gt;&gt;}, meta: %{} }}","ref":"Txpost.Envelope.html#decode_payload/1","title":"Txpost.Envelope.decode_payload/1","type":"function"},{"doc":"Encodes the given Envelope struct and returns a CBOR binary.Examplesiex&gt; Txpost.Envelope.encode(%Txpost.Envelope{ ...&gt; payload: &lt;&lt;161, 100, 100, 97, 116, 97, 161, 101, 114, 97, 119, 116, 120, 74, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0&gt;&gt; ...&gt; }) &lt;&lt;161, 103, 112, 97, 121, 108, 111, 97, 100, 88, 24, 161, 100, 100, 97, 116, 97, 161, 101, 114, 97, 119, 116, 120, 74, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0&gt;&gt;","ref":"Txpost.Envelope.html#encode/1","title":"Txpost.Envelope.encode/1","type":"function"},{"doc":"Signs the Envelope payload with the given ECDSA private key.NOT YET IMPLEMENTED","ref":"Txpost.Envelope.html#sign/2","title":"Txpost.Envelope.sign/2","type":"function"},{"doc":"Returns the given Envelope struct as a map with stringified keys. The pubkey and signature attributes are removed if they are nil.Examplesiex&gt; Txpost.Envelope.to_map(%Txpost.Envelope{ ...&gt; payload: &lt;&lt;161, 100, 100, 97, 116, 97, 161, 101, 114, 97, 119, 116, 120, 74, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0&gt;&gt; ...&gt; }) %{ &quot;payload&quot; =&gt; &lt;&lt;161, 100, 100, 97, 116, 97, 161, 101, 114, 97, 119, 116, 120, 74, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0&gt;&gt; }","ref":"Txpost.Envelope.html#to_map/1","title":"Txpost.Envelope.to_map/1","type":"function"},{"doc":"Verifies the Envelope signature against its payload and public key, returning a boolean.If no signature or public key is present, returns false.Examplesiex&gt; Txpost.Envelope.verify(%Txpost.Envelope{ ...&gt; payload: &lt;&lt;161, 100, 100, 97, 116, 97, 161, 101, 114, 97, 119, 116, 120, 106, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0&gt;&gt;, ...&gt; pubkey: &lt;&lt;2, 170, 75, 142, 232, 142, 111, 76, 138, 31, 212, 197, 4, 20, 227, 157, 8, 252, 150, 79, 61, 83, 205, 99, 54, 225, 193, 254, 122, 200, 147, 51, 180&gt;&gt;, ...&gt; signature: &lt;&lt;48, 68, 2, 32, 24, 134, 241, 47, 243, 122, 86, 199, 199, 220, 173, 209, 38, 189, 238, 84, 197, 20, 218, 193, 190, 35, 88, 95, 214, 137, 204, 206, 156, 21, 223, 5, 2, 32, 67, 243, 10, 255, 17, 52, 68, 176, 250, 253, 199, 208, 16, 167, 132, 183, 206, 49, 147, 241, 61, 117, 231, 254, 197, 52, 109, 45, 247, 78, 210, 62&gt;&gt; ...&gt; }) true","ref":"Txpost.Envelope.html#verify/1","title":"Txpost.Envelope.verify/1","type":"function"},{"doc":"CBOR Envelope","ref":"Txpost.Envelope.html#t:t/0","title":"Txpost.Envelope.t/0","type":"type"},{"doc":"Request payload module, implements BRFC c9a2975b3d19 (CBOR Tx Payload).BRFC c9a2975b3d19 defines a simple structure for encoding a raw Bitcoin transaction alongside arbitrary data attributes and meta data in a CBOR encoded binary.The :data attribute is either be a map with a single raw transaction alongside any other attributes, or alternatively it can be a list of maps containing multiple sets of raw transactions with additional attributes. This allows multiple transactions to be encoded in a single payload.The :meta attribute is a map which can contain any other arbitrary infomation which can be used to help handle the request.ExamplesExample payload containing a single transaction.%Txpost.Payload{ data: %{ &quot;rawtx&quot; =&gt; &lt;&lt;1, 0 ,0 ,0, ...&gt;&gt;, &quot;type&quot; =&gt; &quot;article&quot; }, meta: %{ &quot;path&quot; =&gt; &quot;/posts&quot; } }Example payload containing a list of transactions.%Txpost.Payload{ data: [%{ &quot;rawtx&quot; =&gt; &lt;&lt;1, 0 ,0 ,0, ...&gt;&gt;, &quot;type&quot; =&gt; &quot;article&quot; }, %{ &quot;rawtx&quot; =&gt; &lt;&lt;1, 0 ,0 ,0, ...&gt;&gt;, &quot;type&quot; =&gt; &quot;article&quot; }], meta: %{ &quot;path&quot; =&gt; &quot;/posts&quot; } }","ref":"Txpost.Payload.html","title":"Txpost.Payload","type":"module"},{"doc":"Validates the given parameters and returns a Payload struct or returns a validation error message.Parameters can be passed as either a map or keyword list.Examplesiex&gt; Txpost.Payload.build(data: %{&quot;rawtx&quot; =&gt; &lt;&lt;1, 0 ,0 ,0 ,0 ,0 ,0 ,0 ,0 ,0 &gt;&gt;}) {:ok, %Txpost.Payload{ data: %{&quot;rawtx&quot; =&gt; &lt;&lt;1, 0, 0, 0, 0, 0, 0, 0, 0, 0&gt;&gt;}, meta: %{} }}Returns an error when given invalid params.iex&gt; Txpost.Payload.build(data: &quot;not a map&quot;) {:error, &quot;Invalid param: data&quot;}","ref":"Txpost.Payload.html#build/1","title":"Txpost.Payload.build/1","type":"function"},{"doc":"Decodes the given CBOR binary and returns a Payload struct or returns a validation error message.Examplesiex&gt; Txpost.Payload.decode(&lt;&lt;161, 100, 100, 97, 116, 97, 161, 101, 114, 97, 119, 116, 120, 74, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0&gt;&gt;) {:ok, %Txpost.Payload{ data: %{&quot;rawtx&quot; =&gt; &lt;&lt;1, 0, 0, 0, 0, 0, 0, 0, 0, 0&gt;&gt;}, meta: %{} }}Returns an error when given invalid binary.iex&gt; Txpost.Payload.decode(&lt;&lt;0,1,2,3&gt;&gt;) {:error, &quot;Invalid payload binary&quot;}","ref":"Txpost.Payload.html#decode/1","title":"Txpost.Payload.decode/1","type":"function"},{"doc":"Encodes the given Payload struct and returns a CBOR binary.Examplesiex&gt; Txpost.Payload.encode(%Txpost.Payload{ ...&gt; data: %{&quot;rawtx&quot; =&gt; &lt;&lt;1, 0, 0, 0, 0, 0, 0, 0, 0, 0&gt;&gt;} ...&gt; }) &lt;&lt;161, 100, 100, 97, 116, 97, 161, 101, 114, 97, 119, 116, 120, 74, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0&gt;&gt;","ref":"Txpost.Payload.html#encode/1","title":"Txpost.Payload.encode/1","type":"function"},{"doc":"Encodes the given Payload struct as a CBOR binary and wraps it within an Envelope struct.Examplesiex&gt; Txpost.Payload.encode_envelope(%Txpost.Payload{ ...&gt; data: %{&quot;rawtx&quot; =&gt; &lt;&lt;1, 0, 0, 0, 0, 0, 0, 0, 0, 0&gt;&gt;} ...&gt; }) %Txpost.Envelope{ payload: &lt;&lt;161, 100, 100, 97, 116, 97, 161, 101, 114, 97, 119, 116, 120, 74, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0&gt;&gt; }","ref":"Txpost.Payload.html#encode_envelope/1","title":"Txpost.Payload.encode_envelope/1","type":"function"},{"doc":"Returns the given Payload struct as a map with stringified keys. The meta attribute is removed if it is an empty map.Examplesiex&gt; Txpost.Payload.to_map(%Txpost.Payload{ ...&gt; data: %{&quot;rawtx&quot; =&gt; &lt;&lt;1, 0, 0, 0, 0, 0, 0, 0, 0, 0&gt;&gt;} ...&gt; }) %{ &quot;data&quot; =&gt; %{&quot;rawtx&quot; =&gt; &lt;&lt;1, 0, 0, 0, 0, 0, 0, 0, 0, 0&gt;&gt;} }","ref":"Txpost.Payload.html#to_map/1","title":"Txpost.Payload.to_map/1","type":"function"},{"doc":"CBOR Request Payload","ref":"Txpost.Payload.html#t:t/0","title":"Txpost.Payload.t/0","type":"type"},{"doc":"Very simple router behaviour so your can advertise a single route to handle all incoming transactions.Define a module that implements the handle_tx/2 callback. For example:defmodule MyApp.TxRouter do use Txpost.Router def handle_tx(conn, _params) do case get_req_meta(conn) do %{&quot;type&quot; =&gt; &quot;article&quot;} -&gt; ArticleController.call(conn, :create) %{&quot;type&quot; =&gt; &quot;image&quot;} -&gt; ImageController.call(conn, :create) end end endThe handle_tx/2 callback gives you access to the connection and request parameters, meaning you can use any part of the request, including headers, request meta data or the raw transaction itself, and call the appropriate action to handle the request.As the router is a plug, you can add a single route to your main router to handle all incoming transactions. For example, a Phoenix router implementation may look like:defmodule MyApp.Router do use MyApp, :router pipeline :tx_api do plug :accepts, [&quot;cbor&quot;] plug Txpost.Plug end scope &quot;/tx&quot; do pipe_through :tx_api post &quot;/&quot;, MyApp.TxRouter, [] end endAlternatively, implemented using a Plug router may look like:defmodule MyApp.Router do use Plug.Router plug :match plug Plug.Parsers, parsers: [Txpost.Parsers.CBOR] plug Txpost.Plug plug :dispatch post &quot;/tx&quot;, to: MyApp.TxRouter end","ref":"Txpost.Router.html","title":"Txpost.Router","type":"behaviour"},{"doc":"Returns the request payload meta data.","ref":"Txpost.Router.html#get_req_meta/1","title":"Txpost.Router.get_req_meta/1","type":"function"},{"doc":"Invoked to handle incoming requests.Function recieves the connection and request parameters which will include the raw transaction.Any logic can be used the determine the correct route, and call any &quot;action&quot; function that adheres to the Plug specification and returns the connection.ExamplesUse the request meta data to route the request:def handle_tx(conn, params) do case get_req_meta(conn) do %{&quot;type&quot; =&gt; &quot;article&quot;} -&gt; ArticleController.create(conn, params) %{&quot;type&quot; =&gt; &quot;image&quot;} -&gt; ImageController.create(conn, params) end endUse Shapeshifter to decode the raw transaction.def handle_tx(conn, %{&quot;rawtx&quot; =&gt; rawtx}) do [output | _] = rawtx |&gt; Shapeshifter.to_txo |&gt; Map.get(&quot;out&quot;) case output do %{&quot;s3&quot; =&gt; &quot;article&quot;} -&gt; ArticleController.call(conn, :create) %{&quot;s3&quot; =&gt; &quot;image&quot;} -&gt; ImageController.call(conn, :create) end end","ref":"Txpost.Router.html#c:handle_tx/2","title":"Txpost.Router.handle_tx/2","type":"callback"},{"doc":"A helper plug that adds the following modules to your pipeline.EnvelopeRequired - Implements BRFC 5b82a2ed7b16PayloadDeserializer - Implements BRFC c9a2975b3d19Any of the options accepts by the modules above can be passed to this plug.Exampleplug Txpost.Plug","ref":"Txpost.Plug.html","title":"Txpost.Plug","type":"module"},{"doc":"Callback implementation for Plug.call/2.","ref":"Txpost.Plug.html#call/2","title":"Txpost.Plug.call/2","type":"function"},{"doc":"Callback implementation for Plug.init/1.","ref":"Txpost.Plug.html#init/1","title":"Txpost.Plug.init/1","type":"function"},{"doc":"Plug for ensuring CBOR requests are sent in a valid CBOR envolope as per BRFC 5b82a2ed7b16 (CBOR Tx Envelope).Options:ensure_signed - Ensures the Envelope is signed with a valid signature or riases an InvalidSignatureError. Defaults false.Exampleplug Txpost.Plug.EnvelopeRequired, ensure_signed: true","ref":"Txpost.Plug.EnvelopeRequired.html","title":"Txpost.Plug.EnvelopeRequired","type":"module"},{"doc":"Plug for flattening incoming params decoded from a CBOR request as per BRFC c9a2975b3d19 (CBOR Tx Payload).This will only deserialize a payload when the request has a CBOR-parsable content type.Exampleplug Txpost.Plug.PayloadDeserializer","ref":"Txpost.Plug.PayloadDeserializer.html","title":"Txpost.Plug.PayloadDeserializer","type":"module"},{"doc":"A Plug.Parsers module for parsing CBOR request bodies.CBOR documents that dont decode to maps are parsed into a &quot;_cbor&quot; key to allow param merging. An empty request body is parsed as an empty map.ExampleAdd the parser your app's list of parsers.plug Plug.Parsers, parsers: [ :json, Txpost.Parsers.CBOR ]","ref":"Txpost.Parsers.CBOR.html","title":"Txpost.Parsers.CBOR","type":"module"},{"doc":"Error raised when Envelope signature is invalid.","ref":"Txpost.Envelope.InvalidSignatureError.html","title":"Txpost.Envelope.InvalidSignatureError","type":"exception"},{"doc":"CBOR Tx Payload specificationConcise binary serialisation structure for sending and receiving Bitcoin transactions and artibrary data parameters over HTTP.BRFCTitleAuthor(s)Versionc9a2975b3d19CBOR Tx PayloadLibs1","ref":"cbor-tx-payload.html","title":"CBOR Tx Payload specification","type":"extras"},{"doc":"Applications that send and receive Bitcoin transactions over HTTP often use text serialisation formats such as JSON. When binary data is hex encoded it adds a 100% bandwidth overhead. Even with gzip compression the overhead is around 25%.This specification proposes using CBOR (Concise Binary Object Representation) to encode a simple and flexible data structure that offers the following benefits:A simple data model as familiar as JSONEfficient, binary-friendly format with minimal data overheadSimple schema for transferring Bitcoin transactions alongside arbitrary data parameters and meta dataMultiple transactions can be sent in a single requestCan be used in streaming applications","ref":"cbor-tx-payload.html#overview","title":"CBOR Tx Payload specification - Overview","type":"extras"},{"doc":"The following CBOR structure is described using CDDL (Concise Data Definition Language).Payload = { data: Data / [* Data], ? meta: { * text =&gt; any }, } Data = { rawtx: binary, * text =&gt; any }The Payload type is a map which must contain a data field and may contain a meta field. The value of the data field must be a Data map or array of Data maps. If present, the the meta field must be a map which can contain any arbitrary key/value parameters.The Data type is a map which must contain a rawtx binary value and any other optional arbitrary key/value parameters.The Payload data and meta fields provide namespaces for including arbitrary data alongside the transaction. Use of these fields will be application specific, but the following distinction is advised:The data namespace should be used for including supplementary data parameters that can be seen as related to the resource the transaction relates to. For example, if the transaction contains a hash of a file, but not the file itself, the file data could also be sent to the application alongside the transaction in the datamap.The meta namespace should be used for including arbitrary data useful to the application, but unrelated to the resource the transaction relates to. For example, the meta map could include routing information or authentication parameters.","ref":"cbor-tx-payload.html#payload-data-definition","title":"CBOR Tx Payload specification - Payload data definition","type":"extras"},{"doc":"There are several alternative binary data serialisation formats, such as Protobuf, MessagePack and BSON.CBOR was chosen because it has a well defined specification with implementations in many languages, and strikes the right balance of simplicity and flexibility. CBOR is largely isomorphic to JSON, plus supports byte arrays. Which is exactly what is needed.","ref":"cbor-tx-payload.html#cbor-data-format","title":"CBOR Tx Payload specification - CBOR data format","type":"extras"},{"doc":"A valid HTTP request or response must contain the following:Headers:Content-Type: Must be &quot;application/cbor&quot; or can be any media type with the +suffix &quot;+cbor&quot;, for example: &quot;xxx/yyy+cbor&quot;.Body: The Payload data must be CBOR-encoded.","ref":"cbor-tx-payload.html#http-requests","title":"CBOR Tx Payload specification - HTTP requests","type":"extras"},{"doc":"In a streaming application, a data stream may be composed of a sequence of CBOR-encoded Payload data items concatenated back-to-back. The receiving end will buffer data until one or more complete Payload data items can be decoded. Any remaining data is buffered until it too can be decoded.","ref":"cbor-tx-payload.html#streaming-applications","title":"CBOR Tx Payload specification - Streaming applications","type":"extras"},{"doc":"The following implementations of this BRFC are available:Txpost - ElixirComing soon - JavaScript","ref":"cbor-tx-payload.html#implementations","title":"CBOR Tx Payload specification - Implementations","type":"extras"},{"doc":"This spec is released as an RFC (request for comment) as part of the public review process. Any comments, criticisms or suggestions should be directed toward the Txpost repository issues page.","ref":"cbor-tx-payload.html#comments","title":"CBOR Tx Payload specification - Comments","type":"extras"},{"doc":"CBOR Tx Envelope specificationStandard for serialising a CBOR payload, ensuring consistency when signing the payload.BRFCTitleAuthor(s)Version5b82a2ed7b16CBOR Tx EnvelopeLibs1","ref":"cbor-tx-envelope.html","title":"CBOR Tx Envelope specification","type":"extras"},{"doc":"When sharing data objects, inconsistencies between implementations can cause changes to the data object (for example, key order) which would cause signature verification to fail.The JSON Envelope BRFC described a technique to ensure consitency of the data being signed by encoding the JSON payload inside a parent JSON object (the envelope). This specification proposes using the same technique applied to CBOR (Concise Binary Object Representation) encoded payloads.As CBOR is a concise binary-friendly format, it offers a highly efficient way of encapsulating public keys, signatures and other binary values. CBOR can also be used in streaming applications.","ref":"cbor-tx-envelope.html#overview","title":"CBOR Tx Envelope specification - Overview","type":"extras"},{"doc":"The following CBOR structure is described using CDDL (Concise Data Definition Language).Envelope = { payload: bytes, ? pubkey: bytes, ? signature: bytes }The Envelope type is a map which must contain a payload field, and may contain pubkey and signature fields. The value of the payload field must be a CBOR-encoded binary. If present, the pubkey field must be a Bitcoin public key binary, and the signature field must be an ECDSA signature.","ref":"cbor-tx-envelope.html#envelope-data-definition","title":"CBOR Tx Envelope specification - Envelope data definition","type":"extras"},{"doc":"An ECDSA signature is created by calculating the sha256 hash of the payload binary, and signing the hash with a Bitcoin private key. The resulting signature and the private key's corresponding public key are included in the Envelope data item.The recieving end can verify the signature by calculating the sha256 hash of the payload binary, and verifying the signature against the hash, using the pubkey.","ref":"cbor-tx-envelope.html#signing-algorithm","title":"CBOR Tx Envelope specification - Signing algorithm","type":"extras"},{"doc":"There are several alternative binary data serialisation formats, such as Protobuf, MessagePack and BSON.CBOR was chosen because it has a well defined specification with implementations in many languages, and strikes the right balance of simplicity and flexibility. CBOR is largely isomorphic to JSON, plus supports byte arrays. Which is exactly what is needed.","ref":"cbor-tx-envelope.html#cbor-data-format","title":"CBOR Tx Envelope specification - CBOR data format","type":"extras"},{"doc":"A valid HTTP request or response must contain the following:Headers:Content-Type: Must be &quot;application/cbor&quot; or can be any media type with the +suffix &quot;+cbor&quot;, for example: &quot;xxx/yyy+cbor&quot;.Body: The Envelope data must be CBOR-encoded.","ref":"cbor-tx-envelope.html#http-requests","title":"CBOR Tx Envelope specification - HTTP requests","type":"extras"},{"doc":"In a streaming application, a data stream may be composed of a sequence of CBOR-encoded Envelope data items concatenated back-to-back. The receiving end will buffer data until one or more complete Envelope data items can be decoded. Any remaining data is buffered until it too can be decoded.","ref":"cbor-tx-envelope.html#streaming-applications","title":"CBOR Tx Envelope specification - Streaming applications","type":"extras"},{"doc":"The following implementations of this BRFC are available:Txpost - ElixirComing soon - JavaScript","ref":"cbor-tx-envelope.html#implementations","title":"CBOR Tx Envelope specification - Implementations","type":"extras"},{"doc":"This spec is released as an RFC (request for comment) as part of the public review process. Any comments, criticisms or suggestions should be directed toward the Txpost repository issues page.","ref":"cbor-tx-envelope.html#comments","title":"CBOR Tx Envelope specification - Comments","type":"extras"}]